<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>LLM Chatbot</title>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/4.6.0/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/4.6.0/js/bootstrap.min.js"></script>
    <style>
        body {
            background-color: #f0f0f5;
            display: flex;
            justify-content: center;
            align-items: center;
            height: 100vh;
            margin: 0;
            padding: 20px;
        }
        .container {
            display: flex;
            width: 100%;
            max-width: 1200px;
            height: 90vh;
            border-radius: 15px;
            overflow: hidden;
            background-color: #ffffff;
            box-shadow: 0 4px 15px rgba(0, 0, 0, 0.2);
        }
        .main-chat {
            flex: 1;
            display: flex;
            flex-direction: column;
        }
        .header {
            background-color: #ff6f61;
            color: white;
            padding: 15px;
            text-align: center;
            font-size: 1.4em;
            border-bottom: 1px solid #ddd;
            display: flex;
            justify-content: space-between;
            align-items: center;
        }
        .header img {
            width: 50px;
            border-radius: 50%;
            border: 2px solid #ffffff;
        }
        .messages {
            flex: 1;
            padding: 20px;
            overflow-y: auto;
            background-color: #fafafa;
        }
        .messages .message {
            margin-bottom: 15px;
            padding: 15px;
            border-radius: 12px;
            max-width: 75%;
            word-wrap: break-word;
            box-shadow: 0 1px 5px rgba(0, 0, 0, 0.1);
        }
        .messages .user-message {
            background-color: #ffe6e6;
            margin-left: auto;
            text-align: right;
        }
        .messages .llm-message {
            background-color: #e6f7ff;
            text-align: left;
        }
        .input-area {
            padding: 15px;
            border-top: 1px solid #ddd;
            display: flex;
            align-items: center;
            background-color: #ffffff;
        }
        .input-area input[type="text"] {
            flex: 1;
            padding: 15px;
            font-size: 16px;
            border: 1px solid #ddd;
            border-radius: 30px;
            outline: none;
            transition: border-color 0.3s;
        }
        .input-area input[type="text"]:focus {
            border-color: #ff6f61;
        }
        .input-area button {
            padding: 15px 25px;
            font-size: 16px;
            background-color: #ff6f61;
            color: white;
            border: none;
            border-radius: 30px;
            cursor: pointer;
            margin-left: 10px;
            transition: background-color 0.3s;
        }
        .input-area button:hover {
            background-color: #e65c50;
        }
        .sidebar {
            width: 300px;
            background-color: #f8f9fa;
            border-left: 1px solid #ddd;
            display: flex;
            flex-direction: column;
            padding: 15px;
            box-shadow: inset 4px 0 8px rgba(0,0,0,0.1);
        }
        .sidebar h4 {
            margin-top: 0;
        }
        .sidebar .btn {
            margin-bottom: 10px;
        }
        .sidebar ul {
            list-style: none;
            padding-left: 0;
        }
        .sidebar ul li {
            cursor: pointer;
            padding: 10px;
            border-bottom: 1px solid #ddd;
        }
        .sidebar ul li:hover {
            background-color: #f1f1f1;
        }
        .hidden {
            display: none;
        }
        .btn-primary {
            background-color: #eea885;
            color: rgb(61, 22, 22);
            border: none;
            border-radius: 30px;
            padding: 15px 25px;
            font-size: 16px;
            cursor: pointer;
            transition: background-color 0.3s;
        }
        .btn-primary:hover {
            background-color: #b61d0f;
        }
        .btn-secondary {
            background-color: #acaf0a;
            color: #333;
            border: 1px solid #ddd;
            border-radius: 30px;
            padding: 10px 20px;
            font-size: 14px;
            cursor: pointer;
            transition: background-color 0.3s;
        }

        .btn-secondary:hover {
            background-color: #e9ecef;
        }
    </style>
</head>
<body>
    <div class="container">
        <div class="main-chat">
            <div class="header d-flex justify-content-between align-items-center">
                <div class="title">
                    <img src="https://via.placeholder.com/50/ff6f61/ffffff?text=LLM" alt="Chatbot Logo">
                    <span>Chat with Model: {{ model_name }}</span>
                </div>
                <button class="btn btn-primary" id="toggle-sidebar">Options</button>
            </div>

            <div class="messages" id="messages"></div>

            <div class="input-area d-flex mt-3">
                <input type="text" id="prompt" name="prompt" class="form-control mr-2" placeholder="Type your question here...">
                <button type="submit" id="send-button" class="btn btn-success">Send</button>
            </div>
        </div>

        <div class="sidebar hidden" id="sidebar">
            <h4>Options</h4>
            <button class="btn btn-secondary" id="new-conversation">Start New Chat</button>
            <button class="btn btn-secondary" id="save-conversation">Save Chat</button>
            <button class="btn btn-secondary" id="delete-conversation">Delete Chat</button>
            <hr>
            <h4>Saved Conversations</h4>
            <ul id="conversation-list" class="list-group"></ul>
        </div>
    </div>

    <script>
        $(document).ready(function() {
            function appendMessage(text, isUser = true) {
                const className = isUser ? 'user-message' : 'llm-message';
                $('#messages').append(`<div class="message ${className}">${text}</div>`);
                $('#messages').scrollTop($('#messages')[0].scrollHeight);
            }

            $('#send-button').on('click', function() {
                const prompt = $('#prompt').val();
                if (!prompt.trim()) return;

                appendMessage(prompt);
                $('#prompt').val('');
                
                $.ajax({
                    url: '/invoke_llm',
                    type: 'POST',
                    contentType: 'application/json',
                    data: JSON.stringify({ prompt: prompt }),
                    success: function(response) {
                        appendMessage(response.response, false);
                    },
                    error: function() {
                        appendMessage('Error invoking LLM.', false);
                    }
                });
            });

            $('#prompt').on('keypress', function(e) {
                if (e.which === 13) {
                    $('#send-button').click();
                }
            });

            $('#toggle-sidebar').on('click', function() {
                $('#sidebar').toggleClass('hidden');
                $(this).text($('#sidebar').hasClass('hidden') ? 'Options' : 'Close');
            });

            $('#new-conversation').on('click', function() {
                $.post('/start_new_conversation', function() {
                    $('#messages').empty();
                }).fail(function() {
                    alert('Error starting a new conversation.');
                });
            });

            $('#save-conversation').on('click', function() {
                $.post('/save_conversation', function(response) {
                    alert(response.status);
                }).fail(function() {
                    alert('Error saving the conversation.');
                });
            });

            $('#delete-conversation').on('click', function() {
                $.post('/delete_conversation', function(response) {
                    $('#messages').empty();
                    alert(response.status);
                }).fail(function() {
                    alert('Error deleting the conversation.');
                });
            });

            $('#list-conversations').on('click', function() {
                $.get('/conversations', function(data) {
                    const conversationList = $('#conversation-list').empty();
                    if (data.conversations.length === 0) {
                        conversationList.append('<li class="list-group-item">No conversations saved.</li>');
                    } else {
                        data.conversations.forEach(function(filename) {
                            conversationList.append(`<li class="list-group-item conversation-item" data-filename="${filename}">${filename}</li>`);
                        });
                    }
                }).fail(function() {
                    alert('Error fetching conversations.');
                });
            });

            $(document).on('click', '.conversation-item', function() {
                const filename = $(this).data('filename');
                $.get(`/conversations/${filename}`, function(data) {
                    if (data.conversation) {
                        const details = data.conversation.history.split('\n').map(line => `<div>${line}</div>`).join('');
                        $('#messages').html(details);
                    } else {
                        alert('Error loading conversation.');
                    }
                }).fail(function() {
                    alert('Error fetching conversation details.');
                });
            });
        });
    </script>
</body>
</html>